package com.iver.cit.gvsig.jdbc_spatial.gui.jdbcwizard;

import com.hardcode.driverManager.DriverLoadException;
import com.iver.cit.gvsig.fmap.drivers.DefaultDBDriver;
import com.iver.cit.gvsig.fmap.drivers.VectorialJDBCDriver;
import com.iver.cit.gvsig.fmap.layers.LayerFactory;

/**
*
* Utility class. Keeps connection parameters.
*
* @author Fernando Gonzlez Corts
*/
public class ConnectionSettings {
   private String host;
   private String port;
   private String db;
   private String driver;
   private String user;
   private String name;
   private String passw = null;

   public String getDb() {
       return db;
   }

   public void setDb(String db) {
       this.db = db;
   }

   public String getDriver() {
       return driver;
   }

   public void setDriver(String driver) {
       this.driver = driver;
   }

   public String getHost() {
       return host;
   }

   public void setHost(String host) {
       this.host = host;
   }

   public String getPort() {
       return port;
   }

   public void setPort(String port) {
       this.port = port;
   }

   public String getUser() {
       return user;
   }

   public void setUser(String user) {
       this.user = user;
   }

   public void setName(String name) {
       this.name = name;
   }

   public String getName() {
       return name;
   }

   public String toString() {
       return host + "," + port + "," + db + "," + driver + "," + user + "," +
       name;
   }

   public void setFromString(String _str) {
   	String str = _str;
   	if (str.endsWith(",")) str = str + " ";
   	if (str.startsWith(",")) str = " " + str;
   	
       String[] values = str.split(",");
       host = values[0];
       port = values[1];
       db = values[2];
       driver = values[3];
       user = values[4];
       name = values[5];

       if (values.length == 7) {
           passw = values[6];
       }
   }

   public String getPassw() {
       return passw;
   }

   public void setPassw(String passw) {
       this.passw = passw;
   }

   public String getConnectionString() throws DriverLoadException {
       VectorialJDBCDriver vecDriver = (VectorialJDBCDriver) LayerFactory.getDM()
                                                                         .getDriver(getDriver());

       if (vecDriver instanceof DefaultDBDriver) {
           return ((DefaultDBDriver) vecDriver).getConnectionString(getHost(),
               getPort(), getDb(), getUser(), getPassw());
       }

       String connectionString = vecDriver.getConnectionStringBeginning() +
           "//" + getHost();
       connectionString += (":" + getPort());
       connectionString += ("/" + getDb());

       return connectionString;
   }
}
