package es.prodevelop.cit.gvsig.jdbc_spatial.gui.jdbcwizard;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Toolkit;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.TreeCellRenderer;

public class ConnectionTreeRenderer extends DefaultTreeCellRenderer {
	
	private ImageIcon connImage = new ImageIcon(createResourceUrl("images/conn.png"));
	private ImageIcon disconnImage = new ImageIcon(createResourceUrl("images/disconn.png"));
	
	public Component getTreeCellRendererComponent(JTree tree, Object value,
			boolean selected, boolean expanded, boolean leaf, int row,
			boolean hasFocus) {

		if (value instanceof JDBConnectionTreeLeaf) {
			JDBConnectionTreeLeaf jdbc = (JDBConnectionTreeLeaf) value;
			if (jdbc.getConnectionWithParams().isConnected()) {
				setLeafIcon(connImage);
			} else {
				setLeafIcon(disconnImage);
			}
		}
		
		return super.getTreeCellRendererComponent(
					tree,
					value,
					selected,
					expanded,
					leaf,
					row,
					hasFocus);
	}
	
    private java.net.URL createResourceUrl(String path) {
        return getClass().getClassLoader().getResource(path);
    }

}
